#include <dht.h>

#include <SoftwareSerial.h>
dht DHT;
#include <dht.h>
#define RX 10
#define TX 11
#include <CCS811.h>
#define sensorPower 7
#define sensorPin A0
#define motorPin 2
#define DHT11_PIN 8

SoftwareSerial esp8266(RX,TX);

String AP = "Fran";       // CHANGE ME
String PASS = "12345678"; // CHANGE ME
String API = "PC0WBRF6EDKPIBI3";   // CHANGE ME
String HOST = "184.106.153.149  ";
String PORT = "80";
int countTrueCommand;
int countTimeCommand;
boolean found = false;


// Sensor values
int co2;
int waterLevel;
int tvoc;
int humidity;
int temperature;

CCS811 sensor;


void setup(void)
{
  pinMode(sensorPower, OUTPUT);
  pinMode(motorPin, OUTPUT);
  digitalWrite(sensorPower, LOW);
  
  Serial.begin(115200);
  esp8266.begin(115200);
  sendCommand("AT", 5, "OK");
  sendCommand("AT+CWMODE=1", 5, "OK");
  sendCommand("AT+CWJAP=\"" + AP + "\",\"" + PASS + "\"", 20, "OK");

  /*Wait for the chip to be initialized completely, and then exit*/
  while (sensor.begin() != 0) {
    Serial.println("failed to init chip, please check if the chip connection is fine");
    delay(1000);
  }

  sensor.setMeasCycle(sensor.eCycle_250ms);
}


void loop() {
  int chck = DHT.read11(DHT11_PIN);
  waterLevel = readSensor();
  
  Serial.print("Water level: ");
  Serial.println(waterLevel);

  Serial.print("Temperature: ");
  Serial.println(DHT.temperature);
  Serial.print("Humidity: ");
  Serial.println(DHT.humidity);
  
  if (sensor.checkDataReady() == true) {
    Serial.print("CO2: ");
    co2 = sensor.getCO2PPM();
    tvoc = sensor.getTVOCPPB();
    Serial.print(co2);
    Serial.println("ppm");
    Serial.print("TVOC: ");
    Serial.print(tvoc);
    Serial.println("ppb");
  } else {
    Serial.println("Data is not ready!");
  }
  sensor.writeBaseLine(0x847B);

  String getData = "GET /update?api_key=" + API + "&" + "field1" + "=" + String(waterLevel) + "&" + "field2" + "=" + String(co2) + "&" + "field3" + "=" + String(tvoc) + "&" + "field4" + "=" + String(DHT.humidity) + "&" + "field5" + "=" + String(DHT.temperature);
  sendCommand("AT+CIPMUX=1", 5, "OK");
  sendCommand("AT+CIPSTART=0,\"TCP\",\"" + HOST + "\"," + PORT, 15, "OK");
  sendCommand("AT+CIPSEND=0," + String(getData.length() + 4), 4, ">");
  esp8266.println(getData); delay(1500); countTrueCommand++;
  sendCommand("AT+CIPCLOSE=0", 5, "OK");
  delay(1000);
  //delay cannot be less than measurement cycle
  if (waterLevel < 300) {
    digitalWrite(motorPin, HIGH);
  }
  else {
    digitalWrite(motorPin, LOW);
  }
}


int readSensor() {
  digitalWrite(sensorPower, HIGH);  // Turn the sensor ON
  delay(10);              // wait 10 milliseconds
  waterLevel = analogRead(sensorPin);    // Read the analog value form sensor
  digitalWrite(sensorPower, LOW);   // Turn the sensor OFF
  return waterLevel;             // send current reading
}


void sendCommand(String command, int maxTime, char readReplay[]) {
  Serial.print(countTrueCommand);
  Serial.print(". at command => ");
  Serial.print(command);
  Serial.print(" ");
  while(countTimeCommand < (maxTime*1))
  {
    esp8266.println(command);//at+cipsend
    if(esp8266.find(readReplay))//ok
    {
      found = true;
      break;
    }
  
    countTimeCommand++;
  }
  
  if(found == true)
  {
    Serial.println("OYI");
    countTrueCommand++;
    countTimeCommand = 0;
  }
  
  if(found == false)
  {
    Serial.println("Fail");
    countTrueCommand = 0;
    countTimeCommand = 0;
  }
  
  found = false;
 }
